LibreOffice LibreOffice 25.2 SDK API Reference

Public Member Functions | List of all members
XContentProviderManager Interface Referencepublished

makes it possible to query/register/deregister content providers. More...

`import"XContentProviderManager.idl";`

Inheritance diagram for XContentProviderManager:

## Public Member Functions
com::sun::star::ucb::XContentProvider | registerContentProvider ([in] com::sun::star::ucb::XContentProvider Provider, [in] string Scheme, [in] boolean ReplaceExisting) raises ( com::sun::star::ucb::DuplicateProviderException )
| registers a content provider for a specific URL template. More...
void | deregisterContentProvider ([in] com::sun::star::ucb::XContentProvider Provider, [in] string Scheme)
| deregisters a content provider. More...
sequence< com::sun::star::ucb::ContentProviderInfo > | queryContentProviders ()
| returns a list of information on all registered content providers. More...
com::sun::star::ucb::XContentProvider | queryContentProvider ([in] string Identifier)
| returns the currently active content provider for a content identifier. More...
Public Member Functions inherited from XInterface
any | queryInterface ([in] type aType)
| queries for a new interface to an existing UNO object. More...
void | acquire ()
| increases the reference counter by one. More...
void | release ()
| decreases the reference counter by one. More...

## Detailed Description

makes it possible to query/register/deregister content providers.

Version
  1.0

See also
  XContentProvider

Developers Guide
  Universal Content Broker - Content Provider Proxies
  Universal Content Broker - Unconfigured UCBs

## Member Function Documentation

## ◆ deregisterContentProvider()

void deregisterContentProvider | ( | [in] com::sun::star::ucb::XContentProvider | Provider,
|  | [in] string | Scheme
| ) |  |

deregisters a content provider.

Parameters

  Provider | a content provider to deregister.
  Scheme | the URL scheme for the provided contents. More generally, this may not only be a URL scheme, but a URL template (see registerContentProvider() for a discussion of URL templates).

## ◆ queryContentProvider()

com::sun::star::ucb::XContentProvider queryContentProvider | ( | [in] string | Identifier | ) |

returns the currently active content provider for a content identifier.

Parameters

  Identifier | a content identifier (i.e., a URL).

Returns
  a content provider, or null.

## ◆ queryContentProviders()

sequence< com::sun::star::ucb::ContentProviderInfo > queryContentProviders | ( |  | ) |

returns a list of information on all registered content providers.

Returns
  a list information on content providers.

## ◆ registerContentProvider()

com::sun::star::ucb::XContentProvider registerContentProvider | ( | [in] com::sun::star::ucb::XContentProvider | Provider,
|  | [in] string | Scheme,
|  | [in] boolean | ReplaceExisting
| ) |  |
raises | ( | com::sun::star::ucb::DuplicateProviderException
| ) |  |

registers a content provider for a specific URL template.

See also
  XContentIdentifier

Parameters

  Provider | the content provider to register.

This may be `NULL`, in which case a later XContentProvider::queryContent() with an XContentIdentifier that matches the Scheme will simply return `NULL`. These "dummy" content providers are useful in combination with other content providers that are registered on a wildcard URL template: For example, imagine that you want to route all http URLs to a HTTP content provider, but want to block all URLs for the server `www.dont.go`. One solution would be to register the HTTP content provider on the Scheme `http`, and to register a "dummy" (i.e., `NULL`) content provider on the Scheme `"http://www.dont.go"([/?#].*)?`.

Parameters

  Scheme | the URL scheme for the provided contents. More generally, this may not only be a URL scheme, but a URL template.

A URL template is a regular expression (represented as a string) that specifies a subset of the set of all possible URLs (this subset consists of exactly those URLs that match the regular expression). The language to denote the regular expressions is initially quite limited, but it may be extended in the future:

- `regexp = scheme / simple / translation`
- `scheme = ALPHA *(ALPHA / DIGIT / "+" / "-" / ".")`
- `simple = simple-prefix / simple-authority / simple-domain`
- `translation = trans-prefix / trans-authority / trans-domain`
- `simple-prefix = [string] ".*"`
- `trans-prefix = [string] "(.*)->" [string] "\1"`
- `simple-authority = [string] "([/?#].*)?"`
- `trans-authority = [string] "(([/?#].*)?)->" string "\1"`
- `simple-domain = [string] "[^/?#]*" string "([/?#].*)?"`
- `trans-domain = [string] "([^/?#]*" string "([/?#].*)?)->" string "\1"`
- `string = DQUOTE 1*(schar / sescape) DQUOTE ; DQUOTE is "</code></li> <li><code>schar = &lt any UTF-16 character except " or >`
- `sescape = "\" (DQUOTE / "")`

A `<scheme&gt:` matches any URL of exactly the given scheme (ignoring case), keeping the extension from URL schemes to URL templates backwards compatible. The `<simple&gt:` regexps match any URL starting with a given string literal, followed by arbitrary characters (`<simple-prefix&gt:`), or by arbitrary characters that start with one of '/', '?', or '#', if any (`<simple-authority&gt:`), or by arbitrary characters not including any of '/', '?', or '#', followed by a given string literal, followed by arbitrary characters that start with one of '/', '?', or '#', if any. The comparison of string literals is done ignoring the case of ASCII letters. The `<translation&gt:` regexps match the same URLs as their `<simple&gt:` counterparts, but they also describe how a (local) URL is mapped to another (remote) URL. This mapping is only relevant for methods of the RemoteAccessContentProvider's XParameterizedContentProvider interface; in all other cases, `<translation&gt:` regexps have the same semantics as their `<simple&gt:` counterparts.

Parameters

  ReplaceExisting | `TRUE`: replace the provider possibly registered for the given URL template. The replaced provider will not be deregistered automatically! If the superseding provider gets deregistered, the superseded one will become active again.

`FALSE`: do not register, if another provider is already registered for the given URL template.

Returns
  the replaced content provider, if there was one.

The documentation for this interface was generated from the following file:

- com/sun/star/ucb/XContentProviderManager.idl